//+------------------------------------------------------------------+
//       
//    (  )
//
//+------------------------------------------------------------------+
#property copyright "Copyright 2011, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
#include <ClassCorelation.mqh>
#property indicator_minimum -1
#property indicator_maximum +1
//----    
#property indicator_level1  +0.50
#property indicator_level2   0
#property indicator_level3  -0.50
#property indicator_levelcolor Blue
#property indicator_levelstyle STYLE_DASHDOTDOT
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_plots   3
//--- plot SignOut
#property indicator_label1  "Spirman"
#property indicator_type1   DRAW_LINE
#property indicator_color1  clrRed
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1
//--- plot Label2
#property indicator_label2  "Yukio"
#property indicator_type2   DRAW_LINE
#property indicator_color2  clrBlue
#property indicator_style2  STYLE_SOLID
#property indicator_width2  1
//--- plot Label3
#property indicator_label3  "Pirson"
#property indicator_type3   DRAW_LINE
#property indicator_color3  clrGreen
#property indicator_style3  STYLE_SOLID
#property indicator_width3  1
Correlation DataForCorrelation ;

//---------------------------------------------------------------------------
input int      Wind=30;//   
input int      History=200 ;//   
//---------------------------------------------------------------------------
double         SpirmanOutBuffer[];
double         YukioOutBuffer[];
double         PirsonOutBuffer[] ;

//===========================================================================
int OnInit()
  {
   SetIndexBuffer(0,SpirmanOutBuffer,INDICATOR_DATA);
   SetIndexBuffer(1,YukioOutBuffer,INDICATOR_DATA) ;
   SetIndexBuffer(2,PirsonOutBuffer,INDICATOR_DATA) ;
   ArraySetAsSeries(SpirmanOutBuffer,true) ;
   ArraySetAsSeries(YukioOutBuffer,true) ;
   ArraySetAsSeries(PirsonOutBuffer,true) ;
   //DataForCorrelation.Corrlation() ;
   ArrayInitialize(SpirmanOutBuffer,EMPTY_VALUE) ;
   ArrayInitialize(YukioOutBuffer,EMPTY_VALUE) ;
   ArrayInitialize(PirsonOutBuffer,EMPTY_VALUE) ;
   return(0);
  }
//===============================================================================
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const int begin,
                const double &price[])
  {
      //if (!DataForCorrelation.isNewBar()) return(0) ;
      double CorSpirman,CorYukio,CorPirson,mas1[],mas2[],ended ;
      int i,j ;
      ArrayResize(mas1,Wind,0) ;
      ArrayResize(mas2,Wind,0) ;
      ArraySetAsSeries(price,true) ;
      for (i=0; i < Wind; i++)
         {
            mas1[i]=price[i] ;
         }
      ended=rates_total ;
      if (History < rates_total) ended=History  ;
      for(i=0 ;i< History-Wind ;i++)
         {
            for (j=0 ; j< Wind ; j++)
               {
                  mas2[j]=price[i+j] ;
               }
            CorSpirman=DataForCorrelation.Spirman(mas1,mas2) ;
            CorYukio=DataForCorrelation.Yukio(mas1,mas2) ;
            CorPirson=DataForCorrelation.Pirson(mas1,mas2) ;
            //SpirmanOutBuffer[i]=CorSpirman ;
            //YukioOutBuffer[i]=CorYukio ;
            PirsonOutBuffer[i]=CorPirson ;
         }

   return(rates_total);
  }
//================================================================================
